@echo off
@REM ==================================================
@REM agletsd.cmd for ASDK 1.0.3 on OS/2
@REM       Authors     Danny B. Lange
@REM                   Mitsuru Oshima
@REM                   ONO Kouichi
@REM                   Hideaki Tai
@REM       Date        June 19, 1998
@REM ==================================================

@set DEF_PORT=434

@REM Configurable part (AGLET_EXPORT_PATH and AGLET_PATH are optional)
@REM set AGLET_HOME=C:\Aglets1.0.2
@REM set JDK_HOME=C:\jdk1.1.6
@REM set AGLET_EXPORT_PATH=(';' separated pathlist for "aglets.export.path")
@REM set AGLET_PATH=(';' separated pathlist for "aglets.class.path")

@set JAVA_HOME=

@IF "%AGLET_HOME%"=="" goto ERROR1
@IF NOT EXIST %AGLET_HOME%\lib\aglets.jar goto ERROR2
@IF NOT "%HOME%"=="" goto SKIP1
@ECHO "Warning: HOME is not set. I'll use AGLET_HOME instead."
HOME=%AGLET_HOME%
:SKIP1

@IF "%AGLET_EXPORT_PATH%"=="" set AGLET_EXPORT_PATH=%AGLET_HOME%\public

@IF NOT "%JDK_HOME%"=="" set ASDK_CP=%AGLET_HOME%\lib\aglets.jar;%JDK_HOME%\lib\classes.zip;%CLASSPATH%
@IF     "%JDK_HOME%"=="" set ASDK_CP=%AGLET_HOME%\lib\aglets.jar;%CLASSPATH%

@IF NOT "%JDK_HOME%"=="" set JAVA_HOME=
@IF NOT "%JDK_HOME%"=="" set ASDK_JAVA_CMD=%JDK_HOME%\bin\java.exe
@IF     "%JDK_HOME%"=="" set ASDK_JAVA_CMD=java.exe
@IF NOT "%ASDK_JAVA%"=="" set ASDK_JAVA_CMD=%ASDK_JAVA%

@IF NOT "%LANG%"=="" set ASDK_LANG=%LANG%
@IF     "%LANG%"=="" set ASDK_LANG=en

@IF NOT "%1"=="-verbose" goto LOOP
@echo Your Configurations are...
@echo   HOME=%HOME%
@echo   LANG=%ASDK_LANG%
@echo   JDK_HOME=%JDK_HOME%
@echo   CLASSPATH=%ASDK_CP%
@echo   AGLET_HOME=%AGLET_HOME%
@echo   AGLET_PATH=%AGLET_PATH%
@echo   AGLET_EXPORT_PATH=%AGLET_EXPORT_PATH%

:LOOP

%ASDK_JAVA_CMD% -classpath %ASDK_CP% -Dprogram-name=agletsd -Duser.home=%HOME% -Duser.language=%ASDK_LANG% -Daglets.home=%AGLET_HOME% -Daglets.class.path=%AGLET_HOME%\public;%AGLET_PATH% -Daglets.export.path=%AGLET_HOME%\public;%AGLET_EXPORT_PATH% com.ibm.aglets.tahiti.Main -defaultport %DEF_PORT% %1 %2 %3 %4 %5 %6 %7 %8 %9

if ERRORLEVEL 1 GOTO EXIT

GOTO LOOP

@REM =====
@REM ERROR
@REM =====

:ERROR2
echo Your AGLET_HOME[=%AGLET_HOME%] is wrong!
GOTO EXIT

:ERROR1
echo Please set AGLET_HOME environment variable!
GOTO EXIT

:EXIT
