/*
 * @(#)TalkWindow.java
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 *
 */

package examples.talk;

import java.awt.*;
import java.awt.event.*;
import com.ibm.aglet.util.*;

/**
 * @version     1.00    96/12/19
 * @author      Mitsuru Oshima
 */
public class TalkWindow extends Frame implements ActionListener {
    TextArea text   = new TextArea();
    TextField input = new TextField();
    Panel panel     = new Panel();
    Button button   = new Button("connect");
    AddressChooser dest = null;

    TalkMaster master = null;
    TalkSlave slave = null;

    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == (Object)dest) {
            // item is double clicked
            master.dispatchSlave( dest.getAddress() );
        } else if (e.getSource() == (Object)button) {
            // button for connection
            master.dispatchSlave( dest.getAddress() );
        } else if (e.getSource() == (Object)input) {
            // text input
            text.appendText( input.getText() + "\r\n");
	    if (master != null) {
	        master.sendText( input.getText() );
	    } else if (slave != null) {
	        slave.sendText( input.getText() );
	    }
	    input.setText("");
	}
    }

    public TalkWindow(TalkMaster master) {
	super("Talk");
	this.master = master;
	setLayout(new BorderLayout(5,5));
	dest = new AddressChooser();

        panel.setLayout(new BorderLayout());
        panel.add("Center", input);
        panel.add("East", button);

	add("North", dest);
	add("Center", text);
	add("South", panel);

	dest.addActionListener(this);
	text.setEditable(false);
	input.addActionListener(this);
	button.addActionListener(this);
	
	addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {
		hide();
	    }
	});
    }

    public TalkWindow(TalkSlave slave) {
	super("Talk");
	this.slave = slave;
	setLayout(new BorderLayout());
	add("Center", text);
	add("South", input);

	text.setEditable(false);
	input.addActionListener(this);

	addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {
		hide();
	    }
	});
    }

    public void appendText(String str) {
	text.appendText( str + "\r\n");
    }
}
