/*
 * @(#)MessageException.java
 *
 * (c) Copyright IBM Corp. 1996, 1997, 1998
 *
 * IBM grants you a non-exclusive, non-transferrable License to
 * use this program internally solely for the purposes of testing
 * and evaluating Java Aglet API.
 * You may not distribute, sublicense, lease, rent or use this
 * sample program externally.
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY EXPRESS OR
 * IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE WARRANTY OF
 * NON-INFRINGEMENT AND THE WARRANTIES OF MERCHANTIBILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE.
 * IBM WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY YOU AS
 * A RESULT OF USING THIS SAMPLE PROGRAM. IN NO EVENT WILL IBM BE
 * LIABLE FOR ANY SPECIAL, INDIRECT CONSEQUENTIAL DAMAGES OR LOST
 * PROFITS EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF THEIR
 * OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS OR DATA.
 * IBM WILL NOT BE LIABLE FOR ANY THIRD PARTY CLAIMS AGAINST YOU.
 */

package com.ibm.aglet;

/**
 * Signals that the exception occured while processsing the message.
 *
 * @version     1.10    $Date: 98/04/10 9:36p $
 * @author	Mitsuru Oshima
 */

public class MessageException extends AgletException {
    private Throwable _exception;

    /*
     * Constructs a MessageException
     */
    public MessageException(Throwable ex) {
	_exception = ex;
    }

    /*
     * Constructs a MessageException with the detailed message.
     * @param s the detailed message
     */
    public MessageException(Throwable ex, String s) {
	super(s);
	_exception = ex;
    }

    /**
     * Gets the message occured
     */
    public Throwable getException() {
	return _exception;
    }
}
