/*
 * @(#)MeetingTask.java
 *
 * (c) Copyright IBM Corp. 1996, 1997
 *
 * IBM grants you a non-exclusive, non-transferrable License to
 * use this program internally solely for the purposes of testing
 * and evaluating Java Aglet API.
 * You may not distribute, sublicense, lease, rent or use this
 * sample program externally.
 *
 * THIS ROGRAM IS PROVIDED "AS IS" WITHOUT ANY WARRANTY EXPRESS OR
 * IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE WARRANTY OF
 * NON-INFRINGEMENT AND THE WARRANTIES OF MERCHANTIBILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE.
 * IBM WILL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY YOU AS
 * A RESULT OF USING THIS SAMPLE PROGRAM. IN NO EVENT WILL IBM BE
 * LIABLE FOR ANY SPECIAL, INDIRECT CONSEQUENTIAL DAMAGES OR LOST
 * PROFITS EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF THEIR
 * OCCURRENCE OR LOSS OF OR DAMAGE TO YOUR RECORDS OR DATA.
 * IBM WILL NOT BE LIABLE FOR ANY THIRD PARTY CLAIMS AGAINST YOU.
 */
package com.ibm.agletx.util;

import com.ibm.agletx.patterns.Meeting;
/**
 * This class objectifies a task to be perform upon arrival to a meeting.
 *
 * @version     1.20    $Date: 98/04/14 5:17p $
 * @author      Yariv Aridor
 * @see MeetingsItinerary
 */


public 
abstract class MeetingTask extends Task {

    private Meeting meeting = null;
    
    public MeetingTask (Meeting meeting) {
	this.meeting = meeting;
    }

    public Meeting getMeeting () {
	return meeting;
    }

    /**
     *  Aglet programers should not modify this method
     */  
    public void execute(SeqItinerary itin) throws Exception {
	execute(itin, meeting.ready(itin.getOwnerAglet().getAglet()));
    }

    /**
     * Define the task to be performed upon arrival to a meeting
     * @param itin the  MeetingsItinerary object
     * @param participants enumeration of the current participants in the meeting.
     * @exception Exception if failed to perform the task 
     */ 
    public abstract void execute(SeqItinerary itin, java.util.Enumeration participants) throws Exception ;
}
